import { GetResponseDataTypeFromEndpointMethod } from "@octokit/types";
import * as github from "@actions/github";
declare type Octokit = ReturnType<typeof github.getOctokit>;
declare type WorkflowRun = GetResponseDataTypeFromEndpointMethod<Octokit["actions"]["listWorkflowRuns"]>["workflow_runs"][number];
declare type Artifacts = GetResponseDataTypeFromEndpointMethod<Octokit["actions"]["listWorkflowRunArtifacts"]>["artifacts"][number];
export declare type GetArtifactsForBranchAndWorkflowReturn = {
    artifact: Artifacts;
    workflowRun: WorkflowRun;
} | null;
export declare type GetArtifactsForBranchAndWorkflow = {
    owner: string;
    repo: string;
    branch: string;
    workflow_id: string;
    artifactName: string;
    commit?: string;
};
/**
 * Fetch artifacts from a workflow run from a branch
 *
 * This is a bit hacky since GitHub Actions currently does not directly
 * support downloading artifacts from other workflows
 */
export declare function getArtifactsForBranchAndWorkflow(octokit: Octokit, { owner, repo, workflow_id, branch, commit, artifactName, }: GetArtifactsForBranchAndWorkflow): Promise<GetArtifactsForBranchAndWorkflowReturn>;
export {};
