"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getArtifactsForBranchAndWorkflow = void 0;
var core = __importStar(require("@actions/core"));
// max pages of workflows to pagination through
var MAX_PAGES = 5;
/**
 * Fetch artifacts from a workflow run from a branch
 *
 * This is a bit hacky since GitHub Actions currently does not directly
 * support downloading artifacts from other workflows
 */
function getArtifactsForBranchAndWorkflow(octokit, _a) {
    var e_1, _b;
    var owner = _a.owner, repo = _a.repo, workflow_id = _a.workflow_id, branch = _a.branch, commit = _a.commit, artifactName = _a.artifactName;
    return __awaiter(this, void 0, void 0, function () {
        var currentPage, completedWorkflowRuns, _c, _d, response, workflowRuns, workflowRunsForCommit, e_1_1, _i, completedWorkflowRuns_1, workflowRun, artifacts, foundArtifact;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    core.debug("Fetching workflow " + workflow_id + " in branch: " + branch + (commit ? " and commit: " + commit : "") + "...");
                    currentPage = 0;
                    completedWorkflowRuns = [];
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 6, 7, 12]);
                    _c = __asyncValues(octokit.paginate.iterator(octokit.actions.listWorkflowRuns, {
                        owner: owner,
                        repo: repo,
                        // Below is typed incorrectly, it needs to be a string but typed as number
                        workflow_file_name: workflow_id,
                        branch: branch,
                        status: "completed",
                        per_page: 100,
                    }));
                    _e.label = 2;
                case 2: return [4 /*yield*/, _c.next()];
                case 3:
                    if (!(_d = _e.sent(), !_d.done)) return [3 /*break*/, 5];
                    response = _d.value;
                    workflowRuns = response.data;
                    console.log(workflowRuns);
                    if (!workflowRuns.length) {
                        core.warning("Workflow " + workflow_id + " not found in branch " + branch);
                        return [2 /*return*/, null];
                    }
                    workflowRunsForCommit = commit
                        ? workflowRuns.filter(function (run) { return run.head_sha === commit; })
                        : workflowRuns;
                    if (workflowRunsForCommit.length) {
                        completedWorkflowRuns = completedWorkflowRuns.concat(workflowRunsForCommit);
                        return [3 /*break*/, 5];
                    }
                    if (currentPage > MAX_PAGES) {
                        core.warning("Workflow " + workflow_id + " not found in branch: " + branch + (commit ? " and commit: " + commit : ""));
                        return [2 /*return*/, null];
                    }
                    currentPage++;
                    _e.label = 4;
                case 4: return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 12];
                case 6:
                    e_1_1 = _e.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 12];
                case 7:
                    _e.trys.push([7, , 10, 11]);
                    if (!(_d && !_d.done && (_b = _c.return))) return [3 /*break*/, 9];
                    return [4 /*yield*/, _b.call(_c)];
                case 8:
                    _e.sent();
                    _e.label = 9;
                case 9: return [3 /*break*/, 11];
                case 10:
                    if (e_1) throw e_1.error;
                    return [7 /*endfinally*/];
                case 11: return [7 /*endfinally*/];
                case 12:
                    _i = 0, completedWorkflowRuns_1 = completedWorkflowRuns;
                    _e.label = 13;
                case 13:
                    if (!(_i < completedWorkflowRuns_1.length)) return [3 /*break*/, 16];
                    workflowRun = completedWorkflowRuns_1[_i];
                    core.debug("Checking artifacts for workflow run: " + workflowRun.html_url);
                    return [4 /*yield*/, octokit.actions.listWorkflowRunArtifacts({
                            owner: owner,
                            repo: repo,
                            run_id: workflowRun.id,
                        })];
                case 14:
                    artifacts = (_e.sent()).data.artifacts;
                    if (!artifacts) {
                        core.debug("Unable to fetch artifacts for branch: " + branch + ", workflow: " + workflow_id + ", workflowRunId: " + workflowRun.id);
                    }
                    else {
                        foundArtifact = artifacts.find(function (_a) {
                            var name = _a.name;
                            return name === artifactName;
                        });
                        if (foundArtifact) {
                            core.debug("Found suitable artifact: " + foundArtifact.url);
                            return [2 /*return*/, {
                                    artifact: foundArtifact,
                                    workflowRun: workflowRun,
                                }];
                        }
                    }
                    _e.label = 15;
                case 15:
                    _i++;
                    return [3 /*break*/, 13];
                case 16:
                    core.warning("Artifact not found: " + artifactName);
                    return [2 /*return*/, null];
            }
        });
    });
}
exports.getArtifactsForBranchAndWorkflow = getArtifactsForBranchAndWorkflow;
